//*****************************************************//
//
// Unit: RsFloatEdit.cpp
//
// Purpose: Edit box that excepts numbers only formatted to float
//
// Inherits From: TRsEdit
//
// Project: RapidMisc
//
// Author: Jeff Hiscock -- jhiscock@rapidsi.com
//
// Date: March 2000
//
// Revisions
//
// Copyright Rapid Systems 2000
//******************************************************//
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "RsFloatEdit.h"
#pragma link "RsEdit"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TRsFloatEdit *)
{
        new TRsFloatEdit(NULL);
}
//---------------------------------------------------------------------------
__fastcall TRsFloatEdit::TRsFloatEdit(TComponent* Owner)
        : TRsEdit(Owner)
{
}
//---------------------------------------------------------------------------
namespace Rsfloatedit
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TRsFloatEdit)};
                 RegisterComponents("Rapid - Misc", classes, 0);
        }
}
//---------------------------------------------------------------------------
bool __fastcall TRsFloatEdit::IsDecimal(char Key)
{

    return ( Key==46);
}

void __fastcall TRsFloatEdit::KeyPress(char &Key)
{
   bool ok = true;

   if ( ! IsNumber(Key))
   {

      if (! IsTabOrReturn(Key))
      {
         if (!IsDecimal(Key))
            ok = false;
       }
   }

   if (!ok)
     Key = 0;



}

void __fastcall TRsFloatEdit::SetFloatValue(double value)
{
    Text = FormatFloat(FFormat,value);

    FFloatValue = Text.ToDouble();
}
void __fastcall TRsFloatEdit::DoExit(void)
{

    if (FFormatOnExit)
        Text=FormatFloat(FFormat,GetFloatValue());

    if (FCheckOnExit)
    {
        if (CheckRange())
           TEdit::DoExit();
    }
    else
       TEdit::DoExit();
}

double __fastcall TRsFloatEdit::GetFloatValue()
{
     if (Text.Trim() =="")
        return 0;

     return Text.ToDouble();

}

long  __fastcall TRsFloatEdit::GetCheckValue()
{

   return (long)ceil(GetFloatValue());


}
